#include <objc/Object.h>
#include <stdlib.h>

@interface Foo : Object
{
  char *foo;
  unsigned counter;
}

- (id) init;
- (void) print;
- (void) destroy;
@end

@implementation Foo

- (id) init
{
  if (self = [super init])
    {
      foo = "Test";
      counter = 1;
      
      return self;
    }
  
  return nil;
}

- (void) print
{
  printf ("%s %d\n", foo, counter);
  counter++;
}

- (void) destroy
{
  foo = NULL;
  [self free];
}
@end

int
main (void)
{
  int i = 0;
  id obj = [Foo new];

  for (i; i < 3; i++)
    [obj print];
  [obj destroy];
  
  exit (EXIT_SUCCESS);
}
